PROGRAM OpenMP_Tilraun

   USE omp_lib
   USE Mod_Precision

   IMPLICIT NONE
   INTEGER, PARAMETER               ::   N = 1000
   INTEGER, PARAMETER               ::   M = 1000
   INTEGER                          ::   i,j,k
   REAL(KIND=dp)                    ::   suma, vx
   REAL(KIND=dp), DIMENSION(N)      ::   Aa


!$OMP PARALLEL DO PRIVATE(vx)
   DO j = 1, N
     suma = 0.0_dp
     DO i = 1, M
       DO k = 1, M
         vx = SQRT(SQRT(i*k*0.31_dp))
         suma = suma + SIN(COS(SQRT(0.1_dp*i*k)))/(vx*i+SQRT(k*0.01_dp))
       END DO
     END DO
     Aa(j) = suma
   END DO
!$OMP END PARALLEL DO

   Write(6,*) SUM(Aa)

END PROGRAM OpenMP_Tilraun
!
!
! Some nonsense calculation to show the power of OpenMP.
! In nested do-loops only the outermost loop is parallelized
! and automatically all running indices are declared private.
! Here "vx" but not "Aa" has to be declared explicitly private 
! in order for the program to give correct results.   
!
! On a QuadCore machine the runtime command: time nice ./OpenMP_Tilraun_2
! brings:
!   -20106.7166743636
!
! real    0m24.613s
! user    1m36.278s
! sys     0m0.052s
!
!
